﻿/*************************************\
 *        Hintergrundarbeiten        *
 *                                   *
 * Kapitel: Windows Forms            *
 * Zuordnung: C#-Buch V2.0 9.16      *
 *                                   *
 *  Copyright 2015 by Benjamin Jung  *
\*************************************/
using System;
using System.ComponentModel;
using System.Threading;
using System.Windows.Forms;

namespace CSV20.WinForm_Hintergrundarbeiten
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void buttonStarten_Click(object sender, EventArgs e)
        {
            // Abbruch-Button freigeben und Fortschrittsbalken zurücksetzen
            buttonAbbrechen.Enabled = true;
            buttonStarten.Enabled = false;
            progressBarFortschritt.Value = 0;

            // BackgroundWorker starten
            backgroundWorkerFortschritt.RunWorkerAsync();
        }

        private void buttonAbbrechen_Click(object sender, EventArgs e)
        {
            // Start-Button freigeben
            buttonAbbrechen.Enabled = false;
            buttonStarten.Enabled = true;

            // BackgroundWorker abbrechen
            backgroundWorkerFortschritt.CancelAsync();
        }
        
        private void backgroundWorkerFortschritt_DoWork(object sender, DoWorkEventArgs e)
        {
            for (int i = 1; i <= 100; i++)
            {
                // Prüfen ob Vorgang abgebrochen wurde (durch CancelAsync())
                if (backgroundWorkerFortschritt.CancellationPending)
                {
                    e.Cancel = true;
                    return;
                }

                // aktuelle Position in Fortschrittsbalken anzeigen und aktuelle Zahl speichern
                backgroundWorkerFortschritt.ReportProgress(i);
                e.Result = i;

                // 50 ms warten
                Thread.Sleep(50);
            }
        }

        private void backgroundWorkerFortschritt_ProgressChanged(object sender, ProgressChangedEventArgs e)
        {
            // Wert für Fortschrittsbalken setzen
            progressBarFortschritt.Value = e.ProgressPercentage;
        }

        private void backgroundWorkerFortschritt_RunWorkerCompleted(object sender, RunWorkerCompletedEventArgs e)
        {
            // Meldung ausgeben
            if (e.Cancelled)
                MessageBox.Show("Der Vorgang wurde abgebrochen!");
            else
                MessageBox.Show("Der erreichte Wert war " + (int)e.Result + "!");   // gibt immer 100 aus

            // Start-Button freigeben
            buttonAbbrechen.Enabled = false;
            buttonStarten.Enabled = true;
        }
    }
}